*DECK T16CPO
      SUBROUTINE T16CPO(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C----
C  1- PROGRAMME STATISTICS:
C      NAME     : T16CPO
C      USE      : TRANSFER A WIMS-AECL TAPE16 FILE
C                 TO A DONJON/DRAGON CPO DATA STRUCTURE
C      AUTHOR   : G.MARLEAU
C      CREATED  : 1999/10/21
C      REF      : IGE-244 REV.1
C                 IGE-174 REV.3
C                 IGE-232 REV.2
C                 IGE-208 REV.1
C
C      MODIFICATION LOG
C      --------------------------------------------------------------
C      | DATE AND INITIALS  | MOTIVATIONS
C      --------------------------------------------------------------
C      | 1999/10/21 G.M.    | TRANSFER A WIMS-AECL TAPE16 FILE
C      |                    | TO A DONJON/DRAGON CPO DATA STRUCTURE
C      --------------------------------------------------------------
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      NENTRY : NUMBER OF DATA STRUCTURES USED.          I
C      HENTRY : NAME OF DATA STRUCTURES.                 C(NENTRY)*12
C      IENTRY : TYPE OF DATA STRUCTURES.                 I(NENTRY)
C               = 1 FOR LINKED LIST;
C               = 2 FOR XSM FILE;
C               = 3 FOR SEQUENTIAL BINARY FILE;
C               = 4 FOR SEQUENTIAL ASCII FILE.
C      JENTRY : MODE OF DATA STRUCTURES.                 I(NENTRY)
C               = 0 CREATION MODE;
C               = 1 UPDATE MODE;
C               = 2 READ-ONLY MODE.
C      KENTRY : ADDRESS OF DATA STRUCTURES.              I(NENTRY)
C               FOR IENTRY = 1  LINKED LIST ADDRESS;
C               FOR IENTRY > 1  FILE UNIT NUMBER.
C    OUTPUT
C      ------
C  3- ROUTINES CALLED
C    SPECIFIC T16CPO ROUTINES
C      T16FND : FIND A TAPE16 RECORD
C               EQUIVALENT TO FIND FUNCTION
C               IN APPENDIX E OF EACL RC-1176
C    UTILITIES ROUTINES
C      XABORT : ABORT ROUTINE
C      XDRSET : VECTOR INITIALIZATION ROUTINE
C      LCMGET : DATA STRUCTURE READ ROUTINE
C      LCMPUT : DATA STRUCTURE WRITE ROUTINE
C      LCMSIX : DATA STRUCTURE CHANGE DIRECTORY ROUTINE
C      SETARA : MEMORY ALLOCATION ROUTINE
C      RLSARA : MEMORY RELEASE ROUTINE
C      REDGET : FREE FORMAT READ
C  4- INPUT REQUIREMENTS
C    NENTRY  >= 2
C      IEN = 1 : STRUCTURE IS A LINKED LIST OR XSM FILE
C                CONTAINING THE OUTPUT CPO DATA STRUCTURE.
C                THIS STRUCTURE MUST BE IN CREATION OR
C                UPDATE MODE
C                IENTRY(IEN)<= 2, JENTRY(IEN) <= 1
C      IEN = 2 : STRUCTURE IS A WIMS-AECL TAPE16
C                READONLY SEQUENTIAL BINARY FILE
C                IENTRY(IEN) = 3, JENTRY(IEN) = 2
C      IEN > 2 : STRUCTURES NOT USED
C----
C
      IMPLICIT         NONE
      INTEGER          NENTRY
      CHARACTER        HENTRY(NENTRY)*12
      INTEGER          IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C----
C  MEMORY ALLOCATION
C----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          NAMMIX,MIXRCI,PARRCI,MIXPER,PARPER,
     >                 MIXREG,IFGCPO,IFGCND,IFGMTR,IFGEDI,
     >                 ENET16,ENECPO,VELT16,VELMTR,VELEDI,
     >                 BURNUP,WNKB
C----
C  READ VARIABLES
C----
      CHARACTER        TEXT12*12
      INTEGER          ITYPE,NITMA
      REAL             FLOTT
      DOUBLE PRECISION DFLOTT
C----
C  LOCAL VARIABLES
C----
      INTEGER          IOUT,NSTATE,NTC,MXGRP,MNLOCP,MNCPLP,MNPERT,LSUBT
      CHARACTER        NAMSBR*6,NAMVER*12,NAMDAT*12,NAMMOD*12
      PARAMETER       (IOUT=6,NSTATE=20,NTC=3,MXGRP=89,MNLOCP=11,
     >                 MNCPLP=1,MNPERT=10,LSUBT=72,NAMSBR='T16CPO',
     >                 NAMVER='VERSION 1.0 ',NAMDAT='1999/11/02  ',
     >                 NAMMOD='T16CPO:     ')
      CHARACTER        TEXT4*4,HSIGN*12,NAMDIR*12
      INTEGER          ISTATE(NSTATE),KCHAR(NTC),
     >                 ITITL(18),ISUBT(LSUBT),MAXMIX,MNBURN,
     >                 ITEXT4,ITC,IPCPO,IPT16,ITCPO,NCMIXS,
     >                 IPRINT,ILIST,IMIXT,NMIXT,NEL,NG,NGMTR,
     >                 NMATZ,NM,MTRMSH,NFPR,NZONE,NREGON,NGREAC,
     >                 NRCELA,NRREGI,NGCOND,NGCCPO,IGC,ILASTG
C----
C  DATA
C----
      CHARACTER        NALOCP(MNLOCP+MNCPLP)*4
      INTEGER          IDLCPL(2,MNLOCP+MNCPLP)
      SAVE             NALOCP,IDLCPL
      DATA             NALOCP /'FT  ','MT  ','MD  ','MP  ',
     >                         'MB  ','CT  ','CD  ','CP  ',
     >                         'RT  ','RD  ','RP  ','MTMD'/
      DATA             IDLCPL /  1, 0,  2, 0,  3, 0,  4, 0,
     >                           5, 0,  6, 0,  7, 0,  8, 0,
     >                           9, 0, 10, 0, 11, 0,  2, 3/
C----
C  PRINT CREDITS
C----
      WRITE(IOUT,6900) NAMMOD
      WRITE(IOUT,6910)
C----
C  PARAMETER VALIDATION
C----
      TEXT4='    '
      READ(TEXT4,'(A4)') ITEXT4
C----
C  SET TITLE
C----
      CALL XDRSET(ITITL,18,ITEXT4)
      NAMDIR=NAMSBR
      READ(NAMDIR,'(A4,A2)') (ITITL(ITC),ITC=1,2)
      NAMDIR=NAMVER
      READ(NAMDIR,'(3A4)') (ITITL(ITC),ITC=3,5)
      NAMDIR=NAMDAT
      READ(NAMDIR,'(3A4)') (ITITL(ITC),ITC=6,8)
C----
C  ALLOCATE MEMORY FOR ENERGY
C----
      CALL SETARA(IBASE,  MXGRP,IFGCPO)
      CALL SETARA(IBASE,  MXGRP,IFGCND)
      CALL SETARA(IBASE,  MXGRP,IFGMTR)
      CALL SETARA(IBASE,  MXGRP,IFGEDI)
      CALL SETARA(RBASE,MXGRP+1,ENET16)
      CALL SETARA(RBASE,MXGRP+1,ENECPO)
      CALL SETARA(RBASE,  MXGRP,VELT16)
      CALL SETARA(RBASE,  MXGRP,VELMTR)
      CALL SETARA(RBASE,  MXGRP,VELEDI)
C----
C  NUMBER OF DATA STRUCTURES
C----
      IF(NENTRY .LT. 2) THEN
        CALL XABORT(NAMSBR//
     >  ': AT LEAST TWO DATA STRUCTURES EXPECTED.')
      ENDIF
C----
C  FIRST DATA STRUCTURE IS CPO
C----
      IF(IENTRY(1) .NE. 1 .AND. IENTRY(1) .NE. 2 ) THEN
        CALL XABORT(NAMSBR//
     >  ': LINKED LIST OR XSM FILE EXPECTED FOR CPO.')
      ENDIF
      IPCPO=KENTRY(1)
      ITCPO=0
      IF(JENTRY(1) .EQ. 0) THEN
        HSIGN='L_COMPO'
        READ(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,NTC)
        CALL LCMPUT(IPCPO,'SIGNATURE',NTC,3,KCHAR)
        CALL XDRSET(ISTATE,NSTATE,0)
        ISTATE(3)=1
        ISTATE(4)=2
        ISTATE(6)=1
        ISTATE(7)=MNLOCP+MNCPLP
        ISTATE(8)=MNLOCP
        ISTATE(9)=LSUBT
      ELSE IF(JENTRY(1) .EQ. 1) THEN
        CALL LCMGET(IPCPO,'SIGNATURE',KCHAR)
        WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
        IF(HSIGN .NE. 'L_COMPO') THEN
          CALL XABORT(NAMSBR//': SIGNATURE OF '//HENTRY(1)//
     >      ' IS '//HSIGN//'. L_COMPO EXPECTED.')
        ENDIF
        CALL LCMGET(IPCPO,'STATE-VECTOR',ISTATE)
        IF(ISTATE(3) .NE. 1) CALL XABORT(NAMSBR//
     >  ': INVALID NUMBER OF ISOTOPES ON UPDATE CPO')
        IF(ISTATE(4) .NE. 2) CALL XABORT(NAMSBR//
     >  ': INVALID SCATTERING ANISOTROPY ON UPDATE CPO')
        IF(ISTATE(5) .LE. 1) CALL XABORT(NAMSBR//
     >  ': INVALID NUMBER OF BURNUP STEP ON UPDATE CPO')
        IF(ISTATE(6) .NE. 1) CALL XABORT(NAMSBR//
     >  ': UPDATE CPO DOES NOT MATCH TAPE16 FORMAT')
        IF(ISTATE(7) .NE. MNLOCP+MNCPLP) CALL XABORT(NAMSBR//
     >  ': INVALID NUMBER OF PERTURBATION TYPES ON UPDATE CPO')
        IF(ISTATE(8) .NE. MNLOCP) CALL XABORT(NAMSBR//
     >  ': INVALID NUMBER OF LOCAL PARAMETERS ON UPDATE CPO')
        IF(ISTATE(9) .NE. LSUBT ) CALL XABORT(NAMSBR//
     >  ': INVALID LENGTH OF SUBTITLE ON UPDATE CPO')
        ITCPO=1
        IF(ISTATE(2) .GT. 0) THEN
          CALL LCMGET(IPCPO,'T16CPOENERGY',RBASE(ENECPO))
        ENDIF
      ELSE
        CALL XABORT(NAMSBR//': READONLY MODE FOR '//HENTRY(1)//
     >      ' IS ILLEGAL.')
      ENDIF
      NCMIXS=ISTATE(1)
      NGCCPO=ISTATE(2)
C----
C  SECOND DATA STRUCTURE IS TAPE16 FILE
C----
      IF(IENTRY(2) .NE. 3) THEN
        CALL XABORT(NAMSBR//
     >  ': SEQUENTIAL BINARY FILE EXPECTED FOR TAPE16.')
      ENDIF
      IPT16=KENTRY(2)
      IF(JENTRY(2) .NE. 2) THEN
        CALL XABORT(NAMSBR//': READONLY MODE FOR '//HENTRY(2)//
     >      ' IS REQUIRED.')
      ENDIF
C----
C  RECOVER STATE VECTOR FROM CURRENT CPO FILE
C  AND INITIALIZE DEFAULT INPUT OPTIONS
C----
      IPRINT=1
C----
C  READ DATA UNTIL KEYWORD MIX IS REACHED
C----
      ILIST=0
      IMIXT=0
      NMIXT=1
      NGCOND=0
 100  CONTINUE
     
      CALL REDGET(ITYPE,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(ITYPE.NE.3) CALL XABORT(NAMSBR//
     >  ' KEYWORD EXPECTED')
     
      IF(TEXT12.EQ.';') THEN
        GO TO 105
      ELSE IF(TEXT12.EQ.'EDIT') THEN
      
        CALL REDGET(ITYPE,IPRINT,FLOTT,TEXT12,DFLOTT)
        IF(ITYPE.NE.1) CALL XABORT(NAMSBR//
     >    ': EDIT LEVEL EXPECTED')
      ELSE IF(TEXT12.EQ.'NMIX') THEN
        
        CALL REDGET(ITYPE,NMIXT,FLOTT,TEXT12,DFLOTT)
        IF(ITYPE.NE.1) CALL XABORT(NAMSBR//
     >    ': NUMBER OF MIXTURE EXPECTED')
      ELSE IF(TEXT12.EQ.'CONDG') THEN
       
        CALL REDGET(ITYPE,NGCOND,FLOTT,TEXT12,DFLOTT)
        IF(ITYPE.NE.1) CALL XABORT(NAMSBR//
     >    ': NUMBER OF CONDENSATION GROUP EXPECTED')
        ILASTG=0
     
        DO 101 IGC=0,NGCOND-1
          CALL REDGET(ITYPE,NITMA,FLOTT,TEXT12,DFLOTT)
        
          IF(ITYPE.NE.1) CALL XABORT(NAMSBR//
     >      ': GROUP NUMBER REQUIRED')
         
          IF( NITMA .GT. MXGRP .OR. NITMA .LT. ILASTG) THEN
            CALL XABORT(NAMSBR//
     >      ': INVALID GROUP SEQUENCE PROVIDED')
          ENDIF
       
          IBASE(IFGCND+IGC)=NITMA
 101    CONTINUE
      ELSE IF(TEXT12.EQ.'LIST') THEN
        ILIST=1
      ELSE IF(TEXT12.EQ.'MIX') THEN
        IMIXT=1
        GO TO 105
      ENDIF
      GO TO 100
105   CONTINUE
      IF(ILIST .EQ. 1) CALL T16LST(IPT16)
C----
C  SCAN T16 FOR DIMENSIONING DATA
C----
      CALL T16DIM(IPT16 ,IPRINT,MXGRP ,LSUBT ,ISUBT ,NEL   ,
     >            NG    ,NGMTR ,NMATZ ,NM    ,MTRMSH,NFPR  ,
     >            NZONE ,NREGON,NGREAC,NRCELA,NRREGI,
     >            IBASE(IFGMTR),IBASE(IFGEDI))
C----
C  ANALYZE CONDENSED GROUP STRUCTURE
C----
      CALL T16ENE(IPRINT,MXGRP ,NG    ,NGCOND,NGMTR ,NGREAC,
     >            NGCCPO,
     >            IBASE(IFGCPO),IBASE(IFGCND),IBASE(IFGMTR),
     >            IBASE(IFGEDI),RBASE(ENECPO),RBASE(ENET16),
     >            RBASE(VELT16),RBASE(VELMTR),RBASE(VELEDI))
      MNBURN=ISTATE(5)
C----
C  DEFINE DIMENSIONS ADEQUATELY, ALLOCATE MEMORY AND
C  INITIALIZE
C----
      MAXMIX=NCMIXS+NMIXT
      CALL SETARA(IBASE,                       2*MAXMIX,NAMMIX)
      CALL SETARA(IBASE,       (2+MNLOCP+MNCPLP)*MAXMIX,MIXRCI)
      CALL SETARA(IBASE,  MNPERT*(MNLOCP+MNCPLP)*MAXMIX,MIXPER)
      CALL SETARA(IBASE,                         MAXMIX,MIXREG)
      CALL SETARA(RBASE,                  MNLOCP*MAXMIX,PARRCI)
      CALL SETARA(RBASE,MNPERT*2*(MNLOCP+MNCPLP)*MAXMIX,PARPER)
      CALL XDRSET(IBASE(NAMMIX),                       2*MAXMIX,ITEXT4)
      CALL XDRSET(IBASE(MIXRCI),       (2+MNLOCP+MNCPLP)*MAXMIX,     0)
      CALL XDRSET(IBASE(MIXPER),  MNPERT*(MNLOCP+MNCPLP)*MAXMIX,     0)
      CALL XDRSET(IBASE(MIXREG),                         MAXMIX,     0)
      CALL XDRSET(RBASE(PARRCI),                  MNLOCP*MAXMIX,   0.0)
      CALL XDRSET(RBASE(PARPER),MNPERT*2*(MNLOCP+MNCPLP)*MAXMIX,   0.0)
C----
C  INITIALIZE DEFAULT VALUES FOR ABOVE MIXTURE PARAMETERS
C  VECTORS
C----
      IF(ITCPO .EQ. 1) THEN
        CALL T16MPI(IPCPO ,IPRINT,MAXMIX,MNLOCP,MNCPLP,MNPERT,
     >              NALOCP,IDLCPL,NCMIXS,NGCCPO,
     >              RBASE(ENECPO),IBASE(NAMMIX),IBASE(MIXRCI),
     >              RBASE(PARRCI),RBASE(PARPER))
      ENDIF
C----
C  MODIFIFY VALUES FOR ABOVE VECTORS AS SPECIFIED ON INPUT FILE
C----
      IF(IMIXT .EQ. 1) THEN
        CALL T16GET(MAXMIX,MNLOCP,MNCPLP,MNPERT,NALOCP,IDLCPL,
     >              NCMIXS,MNBURN,
     >              IBASE(NAMMIX),IBASE(MIXRCI),RBASE(PARRCI),
     >              IBASE(MIXPER),RBASE(PARPER),IBASE(MIXREG))
C----
C  SAVE MODIFIED VALUES FOR ABOVE MIXTURE PARAMETERS
C  VECTORS
C----
        CALL T16MPS(IPCPO ,IPRINT,MAXMIX,MNLOCP,MNCPLP,MNPERT,
     >              NALOCP,IDLCPL,NCMIXS,NGCCPO,ITITL ,LSUBT ,
     >              ISUBT ,
     >              RBASE(ENECPO),IBASE(NAMMIX),IBASE(MIXRCI),
     >              RBASE(PARRCI),RBASE(PARPER))
      ENDIF
      CALL RLSARA(RBASE(PARPER))
      CALL RLSARA(RBASE(PARRCI))
C----
C  SAVE UPDATED STATE-VECTOR
C----
      ISTATE(1)=NCMIXS
      ISTATE(2)=NGCCPO
      ISTATE(5)=MNBURN
      CALL LCMPUT(IPCPO,'T16CPOENERGY',NGCCPO+1,2,RBASE(ENECPO))
      CALL LCMPUT(IPCPO,'STATE-VECTOR',NSTATE,1,ISTATE)
C----
C  ALLOCATE MEMORY FOR T16DRV
C----
      CALL SETARA(RBASE,MNBURN,BURNUP)
      CALL SETARA(RBASE,MNBURN,  WNKB)
C----
C  CALL MAIN T16 CROSS SECTION DRIVER
C----
      write(6,*) 'DIM',MNLOCP,MNCPLP,MNPERT,
     >            NALOCP,IDLCPL,NCMIXS,NGCCPO,MNBURN,NG    ,
     >            NGMTR ,NMATZ ,NM    ,MTRMSH,NFPR  ,NZONE ,
     >            NREGON,NGREAC
      CALL T16DRV(IPCPO ,IPT16 ,IPRINT,MNLOCP,MNCPLP,MNPERT,
     >            NALOCP,NCMIXS,NGCCPO,MNBURN,NG    ,NGMTR ,
     >            NMATZ ,MTRMSH,NZONE ,
     >            IBASE(IFGMTR),RBASE(VELMTR),IBASE(NAMMIX),
     >            IBASE(MIXRCI),IBASE(MIXPER),IBASE(MIXREG),
     >            RBASE(BURNUP),RBASE(WNKB)  )
C----
C  RELEASE MEMORY
C----
      CALL RLSARA(RBASE(  WNKB))
      CALL RLSARA(RBASE(BURNUP))
      CALL RLSARA(IBASE(MIXREG))
      CALL RLSARA(IBASE(MIXPER))
      CALL RLSARA(IBASE(MIXRCI))
      CALL RLSARA(IBASE(NAMMIX))
      CALL RLSARA(RBASE(VELEDI))
      CALL RLSARA(RBASE(VELMTR))
      CALL RLSARA(RBASE(VELT16))
      CALL RLSARA(RBASE(ENECPO))
      CALL RLSARA(RBASE(ENET16))
      CALL RLSARA(IBASE(IFGEDI))
      CALL RLSARA(IBASE(IFGMTR))
      CALL RLSARA(IBASE(IFGCND))
      CALL RLSARA(IBASE(IFGCPO))
      WRITE(IOUT,6901) NAMMOD
      RETURN
C----
C  PRINT FORMAT
C----
 6900 FORMAT('->@BEGIN MODULE : ',A12)
 6901 FORMAT('->@END MODULE   : ',A12)
 6910 FORMAT('->@DESCRIPTION  : CONVERT WIMS-TAPE16 TO DRAGON-CPO'/
     >       '->@CREDITS      : G. MARLEAU'/
     >       '->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL'/
     >       '                  ATOMIC ENERGY OF CANADA LIMITED')
      
      END
