*DECK XENLIB
      SUBROUTINE XENLIB(IPLIB,MAXMIX,NMIX,NBISO,NGRP,XEN,MIX,NAME,
     1 USED,DENS)

*
*-----------------------------------------------------------------------
*
*Purpose:
* update the macroscopic cross sections thanks to the Xenon distribution
*
*Copyright:
* Copyright (C) 2010 Ecole Polytechnique de Montreal
*
*Author(s): M. Guyot
*
*Parameters: input/output
* IPLIB   adress of the L_LIBRARY
* MAXMIX  maximum number of mixtures in the library
* NMIX    number of mixtures present in the library
* NBISO   number of isotopes
* NGRP    number of energy groups
* XEN     xenon concentrations in each bundle
* MIX     'ISOTOPESMIX'
* NAME    'ISOTOPESNAME'
* USED    'ISOTOPESUSED'
* DENS    'ISOTOPESDENS' updated
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPLIB,MAXMIX,NMIX,NBISO,NGRP,MIX(NBISO),
     1 NAME(3,NBISO),USED(3,NBISO)
      REAL XEN(NMIX),DENS(NBISO)
*----
*  LOCAL VARIABLES
*----
      INTEGER IMIX,ISO
      REAL TMPDAY(3)
      LOGICAL LBASE(1)
      CHARACTER TEXT*8
      DIMENSION IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),LBASE(1),IBASE(1))
*----
*  RECOVER INFORMATION
*----
      CALL LCMGET(IPLIB,'ISOTOPESMIX',MIX)
      CALL LCMGET(IPLIB,'ISOTOPERNAME',NAME)
      CALL LCMGET(IPLIB,'ISOTOPESUSED',USED)
      CALL LCMGET(IPLIB,'ISOTOPESDENS',DENS)
*----
*  PERFORM CALCULATION
*----
      IMIX=0
      DO 10 ISO=1,NBISO
        WRITE(TEXT,'(2A4)') (NAME(I,ISO),I=1,2)
        IF(TEXT.EQ.'Xe135   ') THEN
          IMIX=IMIX+1
          DENS(ISO)=XEN(IMIX)
        ENDIF
   10 CONTINUE
       
      IF(IMIX.NE.NMIX) CALL XABORT('@XENLIB: Xe135 SHOULD BE EXTRACTED '
     1 //'IN ALL MIXTURES .')

      CALL LCMPUT(IPLIB,'ISOTOPESDENS',NBISO,2,DENS)
*----
*  UPDATE MACROSCOPIC XS
*----
      CALL SETARA(LBASE,MAXMIX,IMASK)
      CALL SETARA(LBASE,NGRP,IMASKL)
      CALL XDLSET(LBASE(IMASK),MAXMIX,.FALSE.)
      CALL XDLSET(LBASE(IMASKL),NGRP,.TRUE.)
      DO 20 I=1,NBISO
       IBM=MIX(I)
       LBASE(IMASK+IBM-1)=.TRUE.
   20 CONTINUE
      ITSTMP=0
      TMPDAY(1)=0.0
      TMPDAY(2)=0.0
      TMPDAY(3)=0.0
*     CALL THE DRAGON SUBROUTINE FOR THE COMPUTATION OF THE MACROSCOPIC XS
      CALL LIBMIX(IPLIB,MAXMIX,NGRP,NBISO,USED,MIX,DENS,LBASE(IMASK),
     1 LBASE(IMASKL),ITSTMP,TMPDAY)

      CALL RLSARA(LBASE(IMASKL))
      CALL RLSARA(LBASE(IMASK))

      RETURN
      END
