/* Author: A. Hebert (2012/03/11) */
/* Fortran-c interface for freesteam */

#if defined(CRAY) || defined(MSDOS)
#define THMSAT THMSAT
#define THMPT THMPT
#define THMTX THMTX

#elif defined(absoft) || defined(SunOS) || defined(Linux) || defined(DEC) || defined(MIPS)
#define THMSAT thmsat_
#define THMPT thmpt_
#define THMTX thmtx_

#else
#define THMSAT thmsat
#define THMPT thmpt
#define THMTX thmtx

#endif

#include "steam.h"
#include "steam_pT.h"
#include "steam_Tx.h"
#include "region.h"

void THMSAT(float *P, float *T){
  double TD = freesteam_region4_Tsat_p((double)*P);
  *T = (float)TD;
}

void THMPT(float *P, float *T, float *RHO, float *H, float *ZK, float *ZMU, float *CP){
  SteamState State = freesteam_set_pT((double)*P, (double)*T);
  *RHO = (float)freesteam_rho(State);  /*density*/
  *H = (float)freesteam_h(State);      /*enthalpy*/
  *ZK = (float)freesteam_k(State);     /*thermal conductivity*/
  *ZMU = (float)freesteam_mu(State);   /*dynamic viscosity*/
  *CP = (float)freesteam_cp(State);    /*isobaric heat capacity*/
}

void THMTX(float *T, float *X, float *RHO, float *H){
  SteamState State = freesteam_set_Tx((double)*T, (double)*X);
  *RHO = (float)freesteam_rho(State);  /*density*/
  *H = (float)freesteam_h(State);      /*enthalpy*/
}
