*DECK EDIBHX
      SUBROUTINE EDIBHX (MAXPTS,IPTRK,NREG,IMERGE)
*
*-----------------------------------------------------------------------
*
*Purpose:
* reset merging indices for the double heterogeneity option (Bihet).
*
*Copyright:
* Copyright (C) 2014 Ecole Polytechnique de Montreal
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version
*
*Author(s): A. Hebert
*
*Parameters: input
* MAXPTS  allocated storage for arrays of dimension NREG.
* IPTRK   pointer to the tracking LCM object (L_TRACK signature).
* NREG    number of volumes in the macro geometry.
* IMERGE  merging indices in the macro geometry.
*
*Parameters: output
* NREG    number of volumes in the composite geometry.
* IMERGE  merging indices in the composite geometry.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER MAXPTS,IPTRK,NREG,IMERGE(MAXPTS)
*----
*  LOCAL VARIABLES
*----
      PARAMETER(NSTATE=40)
      INTEGER ISTATE(NSTATE)
      COMMON IBASE(1)
*
      CALL LCMSIX(IPTRK,'BIHET',1)
      CALL LCMGET(IPTRK,'PARAM',ISTATE)
      IR1=ISTATE(1)
      IR2=ISTATE(2)
      NREG2=ISTATE(3)
      NG=ISTATE(4)
      NSMAX=ISTATE(5)
      CALL SETARA(IBASE,NREG2,IIBI)
      CALL SETARA(IBASE,NG,INS)
      CALL SETARA(IBASE,NSMAX*NG*(IR2-IR1),IMIXGR)
      CALL LCMGET(IPTRK,'IBI',IBASE(IIBI))
      CALL LCMGET(IPTRK,'NS',IBASE(INS))
      CALL LCMGET(IPTRK,'MIXGR',IBASE(IMIXGR))
      CALL LCMSIX(IPTRK,' ',2)
      NREG=NREG2
      DO 20 IKK=1,NREG2
      IF(IBASE(IIBI+IKK-1).GT.IR1) THEN
         I=IBASE(IIBI+IKK-1)-IR1
         DO 10 J=1,NG
         DO 10 K=1,IBASE(INS+J-1)
         IOF=NSMAX*NG*(I-1)+NSMAX*(J-1)+K
         IF(IBASE(IMIXGR+IOF-1).NE.0) THEN
            NREG=NREG+1
            IMERGE(NREG)=IMERGE(IKK)
         ENDIF
   10    CONTINUE
      ENDIF
   20 CONTINUE
      CALL RLSARA(IBASE(IMIXGR))
      CALL RLSARA(IBASE(INS))
      CALL RLSARA(IBASE(IIBI))
      IF(NREG.GT.MAXPTS) CALL XABORT('EDIBHX: MAXPTS IS TOO SMALL.')
      RETURN
      END
