*DECK MACOPT
      SUBROUTINE MACOPT(IPMAC,IPOPT)
*
*-----------------------------------------------------------------------
*
*Purpose:
* update a Macrolib using control variables from a L_OPTIMIZE object.
*
*Copyright:
* Copyright (C) 2012 Ecole Polytechnique de Montreal.
*
*Author(s): A. Hebert
*
*Parameters: input
* IPMAC   pointer to the macrolib to be updated.
* IPOPT   pointer to the L_OPTIMIZE object open in read-only mode.
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPMAC,IPOPT
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NSTATE=40)
      INTEGER ISTATE(NSTATE)
      COMMON BASE(1)
*----
*  GET L_OPTIMIZE INFORMATION
*----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPOPT,'DLEAK-STATE',ISTATE)
      NGRP=ISTATE(1)
      NMIX=ISTATE(2)
      ITYPE=ISTATE(3)
      IDELTA=ISTATE(4)
      NGR1=ISTATE(5)
      NGR2=ISTATE(6)
      IBM1=ISTATE(7)
      IBM2=ISTATE(8)
      NPERT=(NGR2-NGR1+1)*(IBM2-IBM1+1)
*----
*  GET MACROLIB INFORMATION
*----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMAC,'STATE-VECTOR',ISTATE)
      IF(ISTATE(1).NE.NGRP) CALL XABORT('MACOPT: INVALID NGRP.')
      IF(ISTATE(2).NE.NMIX) CALL XABORT('MACOPT: INVALID NMIX.')
      ILEAK=ISTATE(9)
      IF(ITYPE.EQ.2) THEN
         ISTATE(10)=MAX(1,ISTATE(10))
         CALL LCMPUT(IPMAC,'STATE-VECTOR',NSTATE,1,ISTATE)
      ENDIF
*----
*  UPDATE MACROLIB
*----
      CALL SETARA(BASE,NPERT,IVARV)
      CALL SETARA(BASE,3*NMIX,IGAR)
      CALL LCMGET(IPOPT,'VAR-VALUE',BASE(IVARV))
      JPMAC=LCMGID(IPMAC,'GROUP')
      IPERT=0
      DO 100 IGR=NGR1,NGR2
      KPMAC=LCMDIL(JPMAC,IGR)
      IF((IDELTA.EQ.1).AND.(ITYPE.EQ.1).AND.(ILEAK.EQ.1)) THEN
         CALL LCMGET(KPMAC,'DIFF',BASE(IGAR))
         DO 10 IBM=IBM1,IBM2
         IPERT=IPERT+1
   10    BASE(IGAR+IBM-1)=BASE(IVARV+IPERT-1)
         CALL LCMPUT(KPMAC,'DIFF',NMIX,2,BASE(IGAR))
      ELSE IF((IDELTA.EQ.1).AND.(ITYPE.EQ.1).AND.(ILEAK.EQ.2)) THEN
         CALL LCMGET(KPMAC,'DIFFX',BASE(IGAR))
         CALL LCMGET(KPMAC,'DIFFY',BASE(IGAR+NMIX))
         CALL LCMGET(KPMAC,'DIFFZ',BASE(IGAR+2*NMIX))
         DO 20 IBM=IBM1,IBM2
         IPERT=IPERT+1
         BASE(IGAR+IBM-1)=BASE(IVARV+IPERT-1)
         BASE(IGAR+NMIX+IBM-1)=BASE(IVARV+IPERT-1)
   20    BASE(IGAR+2*NMIX+IBM-1)=BASE(IVARV+IPERT-1)
         CALL LCMPUT(KPMAC,'DIFFX',NMIX,2,BASE(IGAR))
         CALL LCMPUT(KPMAC,'DIFFY',NMIX,2,BASE(IGAR+NMIX))
         CALL LCMPUT(KPMAC,'DIFFZ',NMIX,2,BASE(IGAR+2*NMIX))
      ELSE IF((IDELTA.EQ.1).AND.(ITYPE.EQ.2)) THEN
         CALL LCMLEN(KPMAC,'NTOT1',ILONG,ITYLCM)
         IF(ILONG.NE.0.0) THEN
            CALL LCMGET(KPMAC,'NTOT1',BASE(IGAR))
         ELSE
            CALL LCMGET(KPMAC,'NTOT0',BASE(IGAR))
         ENDIF
         DO 30 IBM=IBM1,IBM2
         IPERT=IPERT+1
   30    BASE(IGAR+IBM-1)=BASE(IVARV+IPERT-1)
         CALL LCMPUT(KPMAC,'NTOT1',NMIX,2,BASE(IGAR))
      ELSE IF((IDELTA.EQ.2).AND.(ITYPE.EQ.1).AND.(ILEAK.EQ.1)) THEN
         CALL LCMGET(KPMAC,'DIFF',BASE(IGAR))
         DO 40 IBM=IBM1,IBM2
         IPERT=IPERT+1
         FACT=BASE(IVARV+IPERT-1)
   40    BASE(IGAR+IBM-1)=BASE(IGAR+IBM-1)*FACT
         CALL LCMPUT(KPMAC,'DIFF',NMIX,2,BASE(IGAR))
      ELSE IF((IDELTA.EQ.2).AND.(ITYPE.EQ.1).AND.(ILEAK.EQ.2)) THEN
         CALL LCMGET(KPMAC,'DIFFX',BASE(IGAR))
         CALL LCMGET(KPMAC,'DIFFY',BASE(IGAR+NMIX))
         CALL LCMGET(KPMAC,'DIFFZ',BASE(IGAR+2*NMIX))
         DO 50 IBM=IBM1,IBM2
         IPERT=IPERT+1
         FACT=BASE(IVARV+IPERT-1)
         BASE(IGAR+IBM-1)=BASE(IGAR+IBM-1)*FACT
         BASE(IGAR+NMIX+IBM-1)=BASE(IGAR+NMIX+IBM-1)*FACT
   50    BASE(IGAR+2*NMIX+IBM-1)=BASE(IGAR+2*NMIX+IBM-1)*FACT
         CALL LCMPUT(KPMAC,'DIFFX',NMIX,2,BASE(IGAR))
         CALL LCMPUT(KPMAC,'DIFFY',NMIX,2,BASE(IGAR+NMIX))
         CALL LCMPUT(KPMAC,'DIFFZ',NMIX,2,BASE(IGAR+2*NMIX))
      ELSE IF((IDELTA.EQ.2).AND.(ITYPE.EQ.2)) THEN
         CALL LCMLEN(KPMAC,'NTOT1',ILONG,ITYLCM)
         IF(ILONG.NE.0.0) THEN
            CALL LCMGET(KPMAC,'NTOT1',BASE(IGAR))
         ELSE
            CALL LCMGET(KPMAC,'NTOT0',BASE(IGAR))
         ENDIF
         DO 60 IBM=IBM1,IBM2
         IPERT=IPERT+1
         FACT=BASE(IVARV+IPERT-1)
   60    BASE(IGAR+IBM-1)=BASE(IGAR+IBM-1)*FACT
         CALL LCMPUT(KPMAC,'NTOT1',NMIX,2,BASE(IGAR))
      ENDIF
  100 CONTINUE
      CALL RLSARA(BASE(IGAR))
      CALL RLSARA(BASE(IVARV))
      IF(IPERT.NE.NPERT) CALL XABORT('MACOPT: UPDATE FAILURE.')
      RETURN
      END
