*DECK SPHEMB
      SUBROUTINE SPHEMB(IPLIB,IPCPO,NGRP,NMIX,MIXUPD)
*
*-----------------------------------------------------------------------
*
*Purpose:
*  build embedded macrolib and recover depletion data from the
*  multicompo.
*
*Copyright:
* Copyright (C) 2008 Ecole Polytechnique de Montreal
*
*Author(s): A. Hebert, R. Chambon
*
*Parameters: input/output
* IPLIB   address of the microlib LCM object.
* IPCPO   address of the multicompo object.
* NGRP    number of energy groups.
* NMIX    maximum number of material mixtures in the microlib.
* MIXUPD  tag for mixture which will be updated
*
*-----------------------------------------------------------------------
*
*----
*  SUBROUTINE ARGUMENTS
*----
      INTEGER IPLIB,IPCPO,NGRP,NMIX
      INTEGER MIXUPD(NMIX)
*----
*  LOCAL VARIABLES
*----
      PARAMETER (NSTATE=40,IOUT=6)
      CHARACTER HSMG*131
      LOGICAL LBASE(1)
      INTEGER ISTATE(NSTATE),IST1(NSTATE),IST2(NSTATE),IBASE(1)
      REAL TMPDAY(3)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),LBASE(1),IBASE(1))
*----
*  RECOVER THE DEPLETION CHAIN
*----
      CALL LCMLEN(IPLIB,'DEPL-CHAIN',ILENG1,ITYLCM)
      CALL LCMLEN(IPCPO,'DEPL-CHAIN',ILENG2,ITYLCM)
      IF((ILENG1.NE.0).AND.(ILENG2.NE.0)) THEN
        CALL LCMSIX(IPCPO,'DEPL-CHAIN',1)
        CALL LCMGET(IPCPO,'STATE-VECTOR',IST1)
        CALL LCMSIX(IPCPO,' ',2)
        CALL LCMSIX(IPLIB,'DEPL-CHAIN',1)
        CALL LCMGET(IPLIB,'STATE-VECTOR',IST2)
        CALL LCMSIX(IPLIB,' ',2)
        DO 100 I=1,NSTATE
        IF(IST1(I).NE.IST2(I)) THEN
          WRITE(HSMG,'(40HSPHEMB: INVALID STATE-VECTOR COMPONENT (,I2,
     1    36H) FOR DEPL-CHAIN DATA IN MULTICOMPO ,1H.)') I
          CALL XABORT(HSMG)
        ENDIF
  100   CONTINUE
      ELSE IF((ILENG1.EQ.0).AND.(ILENG2.NE.0)) THEN
        CALL LCMSIX(IPCPO,'DEPL-CHAIN',1)
        CALL LCMSIX(IPLIB,'DEPL-CHAIN',1)
        CALL LCMEQU(IPCPO,IPLIB)
        CALL LCMSIX(IPLIB,' ',2)
        CALL LCMSIX(IPCPO,' ',2)
      ENDIF
*----
*  COMPUTE THE MACROSCOPIC X-SECTIONS
*----
      CALL LCMGET(IPLIB,'STATE-VECTOR',ISTATE)
      MAXMIX=ISTATE(1)
      IF(MAXMIX.NE.NMIX) CALL XABORT('SPHEMB: INVALID NMIX.')
      NBISO=ISTATE(2)
      CALL SETARA(LBASE,MAXMIX,IMASK)
      CALL SETARA(LBASE,NGRP,IMASKL)
      CALL LCMIOF(IPLIB,'ISOTOPESUSED',IISONA)
      CALL LCMIOF(IPLIB,'ISOTOPESMIX',IISOMI)
      CALL LCMIOF(IPLIB,'ISOTOPESDENS',IDENIS)
      CALL XDLSET(LBASE(IMASK),MAXMIX,.FALSE.)
      CALL XDLSET(LBASE(IMASKL),NGRP,.TRUE.)
      DO 110 ISOT=1,NBISO
        IBM=IBASE(IISOMI+ISOT-1)
        IF(IBM.GT.0) THEN
          IF(MIXUPD(IBM).NE.0) LBASE(IMASK+IBM-1)=.TRUE.
        ENDIF
  110 CONTINUE
      ITSTMP=0
      TMPDAY(1)=0.0
      TMPDAY(2)=0.0
      TMPDAY(3)=0.0
      CALL LIBMIX(IPLIB,MAXMIX,NGRP,NBISO,IBASE(IISONA),IBASE(IISOMI),
     1         BASE(IDENIS),LBASE(IMASK),LBASE(IMASKL),ITSTMP,TMPDAY)
      CALL RLSARA(LBASE(IMASKL))
      CALL RLSARA(LBASE(IMASK))
      RETURN
      END
